<template>
	<v-container class="field-show flex-grow-1" :class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
		<v-skeleton-loader v-if="isLoading" type="card" min-height="500px" />
		<v-card v-else-if="hasError" rounded="lg">
			<v-card-text> Error loading field </v-card-text>
		</v-card>
		<v-card v-else-if="field" rounded="lg" class="overflow-hidden">
			<collect-map
				:area="area"
				:locations="{
					type: 'FeatureCollection',
					features: locations.filter(({ id }) => locationCollections[0].features.includes(id)),
				}"
			/>
			<v-card-title class="d-flex">
				{{ field.name }}
				<field-edit-button class="ml-1" :field="field" />
			</v-card-title>

			<v-card-actions>
				<create-sampling-collection-button
					v-if="stratifications.length > 0 && samplingCollectionsAreLoaded"
					:fieldId="field.id"
					:locationCollectionId="locationCollections[0] && locationCollections[0].id"
					:draftSamplingCollections="draftSamplingCollections"
				/>
				<template v-else>
					<v-menu offset-y :close-on-content-click="true" v-model="isMenuOpen">
						<template v-slot:activator="{ on, attrs }">
							<v-btn rounded color="primary" dark v-bind="attrs" v-on="on" class="ml-1">
								Generate Sampling Locations<v-icon>mdi-chevron-down</v-icon></v-btn
							>
						</template>
						<v-list>
							<add-stratification-dialog v-slot="{ attrs, on }" @open="isMenuOpen = false">
								<v-list-item v-bind="attrs" v-on="on">
									<v-list-item-title>Stratify</v-list-item-title>
								</v-list-item>
							</add-stratification-dialog>
							<v-list-item @click="showDemoDialog = true">
								<v-list-item-title>Create Demo Locations</v-list-item-title>
							</v-list-item>
						</v-list>
					</v-menu>
				</template>
			</v-card-actions>
			<v-card-text>
				<p class="mb-2 text-h6">Details</p>
				<div>
					<div class="font-weight-bold">Address</div>
					<p class="ml-2">
						<field-address :address="field.address" :area="area" />
					</p>
				</div>
				<div class="mb-4">
					<div class="font-weight-bold">Contact</div>
					<ul v-if="field.contactPoints.length > 0">
						<field-contact v-for="(contact, i) in field.contactPoints" :key="i" :contact="contact" />
					</ul>
					<ul v-else>
						<li>No contacts yet.</li>
					</ul>
				</div>
				<div v-if="area" class="mb-4">
					<div class="font-weight-bold">
						Boundary
						<area-edit-button v-if="stratifications.length === 0 && area.properties.drawn" :area="area" />
					</div>
					<ul>
						<li>
							<div class="d-flex align-center">area: {{ areaByUnit.hectares }} ha ({{ areaByUnit.acres }} acres)</div>
						</li>
					</ul>
				</div>
				<div v-if="stratifications" class="mb-4">
					<div class="font-weight-bold">Stratifications</div>
					<ul v-if="stratifications.length > 0">
						<li v-for="(stratification, i) in stratifications" :key="i">
							<div v-if="stratification.name">
								{{ stratification.name }}
								<stratification-delete-button v-if="stratification.isDemo" :stratification="stratification" />
							</div>
							<div class="text-caption">
								{{ new Date(stratification.dateCreated).toLocaleString() }}
							</div>
							<view-stratification-details-button :stratificationId="stratification.id" />
						</li>
					</ul>
					<ul v-else>
						<li>No stratifications yet.</li>
					</ul>
				</div>
				<div class="mb-4">
					<div class="font-weight-bold">Sampling Collections</div>
					<ul v-if="samplingCollections.length > 0">
						<li v-for="(samplingCollection, i) in samplingCollections" :key="i">
							<div v-if="samplingCollection.name">
								<a :href="`/sampling-collection/${samplingCollection.id}`">{{ samplingCollection.id }}</a>
								({{ draftSamplingCollections.includes(samplingCollection) ? 'In progress' : 'Submitted' }})
							</div>
							<div class="text-caption">
								{{ getSamplingProgress(samplingCollection) }}
								<p class="mb-1">{{ new Date(samplingCollection.dateCreated).toLocaleString() }}</p>
							</div>
						</li>
					</ul>
					<ul v-else>
						<li>No sampling collections yet.</li>
					</ul>
				</div>
			</v-card-text>
		</v-card>
		<confirm-dialog
			v-model="showDemoDialog"
			title="Create Demo Locations"
			:message="[
				'Creating a demo will randomly place 3 points in your field. This allows you to try the in-field navigation and sampling collection experiences in the app.',
				'The demo points are not based on a stratification algorithm.',
				'You will need to delete the demo points before creating a stratification using the SoilStack service.',
			]"
			:loading="false"
			button="Generate Demo"
			button-color="primary"
			hideIcon
			@cleanup="
				demoPointsError = null;
				demoPointsIsLoading = false;
			"
			:error="demoPointsError"
			:isLoading="demoPointsIsLoading"
			@confirm="createDemoPoints"
		/>
	</v-container>
</template>

<script lang="ts">
import { computed, ComputedRef, defineComponent, ref, SetupContext } from '@vue/composition-api';
import { area as turfArea } from '@turf/turf';
import AddStratificationDialog from '@/components/dialog/AddStratificationDialog.vue';
import CollectMap from '@/components/map/CollectMap.vue';
import { useAllResources } from '@/store/modules/resources';
import { useAllSamplingCollections } from '@/store/modules/samplingCollections';
import { LocationCollection, SamplingCollection } from '@/store/types';
import ConfirmDialog from '../../components/dialog/ConfirmDialog.vue';
import { SQUARE_METERS_PER_ACRE, SQUARE_METERS_PER_HECTARE } from '../../constants';
import soilApiService from '../../services/soilApiService';
import { generateDemoStratification } from '../../utils/demoStratification';
import ViewStratificationDetailsButton from '../stratify/ViewStratificationDetailsButton.vue';
import AreaEditButton from './Area/AreaEditButton.vue';
import CreateSamplingCollectionButton from './CreateSamplingCollectionButton/CreateSamplingCollectionButton.vue';
import FieldAddress from './FieldAddress/FieldAddress.vue';
import FieldContact from './FieldContact/FieldContact.vue';
import FieldEditButton from './FieldEdit/FieldEditButton.vue';
import StratificationDeleteButton from './StratificationDeleteButton.vue';

export default defineComponent({
	components: {
		CollectMap,
		FieldAddress,
		FieldContact,
		CreateSamplingCollectionButton,
		FieldEditButton,
		AreaEditButton,
		AddStratificationDialog,
		StratificationDeleteButton,
		ConfirmDialog,
		ViewStratificationDetailsButton,
	},
	props: {
		id: { type: String, required: true },
	},
	setup(props, { root }: SetupContext) {
		const { isLoading, isLoaded, hasError } = useAllResources(root.$store);
		const { isLoaded: samplingCollectionsAreLoaded } = useAllSamplingCollections(root.$store);
		const field = computed(() => root.$store.getters['resources/getFieldById'](props.id));
		const stratifications = computed(() => root.$store.getters['resources/getStratificationsByFieldId'](props.id));
		const area = computed(() => root.$store.getters['resources/getAreasByFieldId'](props.id)?.[0]);
		const locationCollections: ComputedRef<LocationCollection[]> = computed(() =>
			root.$store.getters['resources/getLocationCollectionsByFieldId'](props.id)
		);
		const locations = computed(() => root.$store.getters['resources/getLocationsByFieldId'](props.id));
		const draftSamplingCollections = computed(() => {
			const locationCollectionIds = locationCollections.value.map(({ id }) => id);
			const draftSamplingCollections: SamplingCollection[] = root.$store.getters['samplingCollections/getByFieldId'](
				props.id
			);
			const draftsWithStratifications = draftSamplingCollections.filter((sc) =>
				locationCollectionIds.includes(sc.object)
			);
			return draftsWithStratifications;
		});
		const submittedSamplingCollections = computed(() =>
			root.$store.getters['resources/getSamplingCollectionsByFieldId'](props.id)
		);
		const samplingCollections = computed(() => [
			...submittedSamplingCollections.value,
			...draftSamplingCollections.value,
		]);
		const showStratifyDialog = ref(false);
		const showDemoDialog = ref(false);
		const demoPointsIsLoading = ref(false);
		const demoPointsError = ref<string | null>(null);
		const isMenuOpen = ref(false);

		const getSamplingProgress = (samplingCollection: SamplingCollection) =>
			`${samplingCollection.members.length} / ${locationCollections.value[0].features.length} locations collected`;

		const createDemoPoints = async () => {
			demoPointsIsLoading.value = true;
			demoPointsError.value = null;
			try {
				const strat = generateDemoStratification(field.value, area.value);
				await soilApiService.createStratification(strat, area.value.id);
				demoPointsIsLoading.value = false;
				showDemoDialog.value = false;
				root.$store.dispatch('resources/getAllResources');
			} catch (error) {
				demoPointsError.value = 'There was an error creating demo points. Please try again.';
			} finally {
				demoPointsIsLoading.value = false;
			}
		};

		const areaByUnit = computed(() => {
			const squareMeters = area.value ? turfArea(area.value) : 0;
			const acres = (squareMeters / SQUARE_METERS_PER_ACRE).toFixed(2);
			const hectares = (squareMeters / SQUARE_METERS_PER_HECTARE).toFixed(2);
			return { acres, hectares };
		});

		return {
			createDemoPoints,
			isLoading,
			isLoaded,
			field,
			area,
			stratifications,
			locationCollections,
			locations,
			hasError,
			draftSamplingCollections,
			samplingCollections,
			getSamplingProgress,
			areaByUnit,
			showStratifyDialog,
			showDemoDialog,
			demoPointsError,
			demoPointsIsLoading,
			isMenuOpen,
			samplingCollectionsAreLoaded,
		};
	},
});
</script>

<style>
.field-show a {
	font-weight: 500;
	text-decoration: none;
}
</style>
